/***************************************************************************

    M.A.M.E.32  -  Multiple Arcade Machine Emulator for Win32
    Win32 Portions Copyright (C) 1997-98 Michael Soderstrom and Chris Kirmse
    
    This file is part of MAME32, and may only be used, modified and
    distributed under the terms of the MAME license, in "readme.txt".
    By continuing to use, modify or distribute this file you indicate
    that you have read the license and understand and accept it fully.

 ***************************************************************************/

#ifndef __KEYBOARD_H__
#define __KEYBOARD_H__

#include "osdepend.h"

#define OSD_MAX_VALUE (OSD_MAX_PSEUDO)
struct OSDKeyboard
{
    int             (*init)(options_type *options);
    void            (*exit)(void);
    int             (*key_pressed)(int keycode);
    int             (*key_pressed_memory)(int keycode);
    int             (*key_pressed_memory_repeat)(int keycode,int speed);
    int             (*read_key_immediate)(void);
    int             (*read_key)(int translate);
    int             (*read_keyrepeat)(int translate);
    const char*     (*key_name)(int keycode);

    void            (*PressKey)(int keycode);
    BOOL            (*OnMessage)(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam, LRESULT* pResult);
};

extern struct OSDKeyboard Keyboard;

extern int Keyboard_KeyToPseudoCode(int keycode);

#endif
